#!/bin/bash

module load LUMI/23.03 partition/G PrgEnv-cray/8.3.3 cce/15.0.1 cray-mpich/8.1.25
mpic++ -c -I. -o main.mpi.o main.mpi.cpp
hipcc --offload-arch=gfx90a -c -I. -o stream.hip.o stream.hip.cpp
hipcc --offload-arch=gfx90a -c -I. -o device_affinity.o device_affinity.cpp
CC -c -I. -o core_affinity.o core_affinity.cpp
LIB=$(hipconfig --path)/lib
CC -target-accel=amd_gfx90a -o main core_affinity.o main.mpi.o stream.hip.o device_affinity.o -L$LIB -Wl,-rpath=$LIB -lamdhip64

