#include "hip/hip_runtime.h"
#include "hip/hip_runtime_api.h"

static inline void HIP_CALL(hipError_t err) { 
    if (err != hipSuccess) { 
	throw std::runtime_error(hipGetErrorString(err)); 
    } 
    auto err_last = hipGetLastError(); 
    if (err_last != hipSuccess) { 
	throw std::runtime_error(hipGetErrorString(err_last)); 
    } 
}

static inline std::string rank2str(int rank) {
	return std::string("rank=") + std::to_string(rank) + ": ";
}
