#include <mpi.h>
#include <iostream>

extern void hip_memcopy(int rank);
extern int hip_stream(int rank);
extern void core_affinity(int rank);
extern void device_affinity(int rank);

int main(int argc, char **argv)
{
	MPI_Init(&argc, &argv);
	int size, rank;
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	std::cout << ">> rank=" << rank << std::endl;
	MPI_Barrier(MPI_COMM_WORLD);
	core_affinity(rank);
	MPI_Barrier(MPI_COMM_WORLD);
	device_affinity(rank);
	MPI_Barrier(MPI_COMM_WORLD);
	hip_stream(rank);
	MPI_Barrier(MPI_COMM_WORLD);
	for (int i = 1; i<16; i *= 2) {
		if (rank % i == 0)
		    hip_memcopy(rank);
	}
	MPI_Finalize();
	return 0;
}
